!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004, 2005. All rights reserved.
!---------------------------------------------------------------------
!= Subroutine DisturbEnv
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: disturbenv.f90,v 1.4 2006/07/11 01:38:37 sugiyama Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!ǥեȤξͿ뤿Υ롼. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
!  * ǽʾΥפ䤹
!  * 顼 gf4f90io 
!

subroutine DisturbEnv(                                            &
  &    cfgfile, xz_PotTemp, xz_Exner, pz_VelX, xr_VelZ, xza_MixRt,&
  &    xz_Km, xz_Kh                                               &
  &  )
  !
  !ǥեȤξͿ뤿Υ롼. 
  !
  
  !⥸塼ɤ߹
  use gridset,    only:DimXMin,         &!  X β
    &                  DimXMax,         &!  X ξ
    &                  DimZMin,         &!  Z β
    &                  DimZMax,         &!  Z ξ
    &                  MarginZ,          &! ׻ΰΥޡ
    &                  RegZMin,         &! ʪΰ Z β
    &                  DelZ,            &! Z ι
    &                  SpcNum,          &! Žؼο
    &                  XMin, XMax,      &! 
    &                  ZMin, ZMax,      &! 
    &                  s_X,             &! X ɸ(顼ʻ)
    &                  s_Z               ! Z ɸ(顼ʻ)
  use fileset,    only:RandomFile        ! ե
  use basicset,   only:                  &
    &                  SpcWetMolFr,     &!Žʬν
    &                  MolWtWet,        &!Žʬʬ
    &                  MolWtDry,        &!ʬʬ
    &                  xz_TempBasicZ,   &! ܾβ
    &                  xz_PressBasicZ,  &! ܾΰ
    &                  xz_ExnerBasicZ,  &! ̵
    &                  xza_MixRtBasicZ    ! ܾκ
  use Boundary, only:  xza_BoundaryXCyc_xza , &!
    &                  xza_BoundaryZSym_xza 
  use ECCM,     only:  ECCM_MolFr


  !ۤηػ
  implicit none
  
  !ѿ
  character(*), intent(in) :: cfgfile
  real(8), intent(out)  :: pz_VelX(DimXMin:DimXMax,DimZMin:DimZMax)  
                                    !ʿ®ξʬ
  real(8), intent(out)  :: xr_VelZ(DimXMin:DimXMax,DimZMin:DimZMax) 
                                    !ľ®ξʬ 
  real(8), intent(out)  :: xz_Exner(DimXMin:DimXMax,DimZMin:DimZMax)  
                                    !ʡؿξʬ 
  real(8), intent(out)  :: xz_PotTemp(DimXMin:DimXMax,DimZMin:DimZMax)  
                                    !̤ξʬ 
  real(8), intent(out)  :: xza_MixRt(DimXMin:DimXMax,DimZMin:DimZMax, SpcNum)  
                                    !Žʬκ(ʬ)
  real(8), intent(out)  :: xz_Km(DimXMin:DimXMax,DimZMin:DimZMax)
                                    !ư̤ФȻ
  real(8), intent(out)  :: xz_Kh(DimXMin:DimXMax,DimZMin:DimZMax)
                                    !ǮФȻ
  real(8), parameter         :: Pi = 3.1415926535897932385d0 
                                    !߼Ψ
  integer       :: i, k, s, n
  real(8)       :: Humidity         !м
  real(8)       :: XcRate           !濴(ʿ)ΰФ
  real(8)       :: XrRate           !Ⱦ(ʿ)ΰФ
  real(8)       :: ZcRate           !濴(ľ)ΰФ
  real(8)       :: ZrRate           !Ⱦ(ľ)ΰФ
  real(8)       :: Xc               !濴(ʿ)
  real(8)       :: Xr               !Ⱦ(ʿ)
  real(8)       :: Zc               !濴(ľ)
  real(8)       :: Zr               !Ⱦ(ľ)
  real(8)       :: beta(DimXMin:DimXMax, DimZMin:DimZMax)
                                    !κͤФ
  real(8)       :: DelMax           !̾κ
  real(8)       :: Random           !ե뤫
  character(20) :: Type             !̾Υ
  real(8)       :: xz_MolFr(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                    !

  !-------------------------------------------------------------
  ! 
  !-------------------------------------------------------------
  !NAMELIST եɤ߹
  NAMELIST /disturbset/ &
    & Type, DelMax, XrRate, XcRate, ZrRate, ZcRate, &
    & Humidity

  open (10, FILE=cfgfile)
  read(10, NML=disturbset)
  close(10)
  
  !
  pz_VelX    = 0.0d0
  xr_VelZ    = 0.0d0
  xz_Exner   = 0.0d0
  xz_PotTemp = 0.0d0
  xza_MixRt  = 0.0d0
  xz_Km      = 0.0d0
  xz_Kh      = 0.0d0

  !-------------------------------------------------------------
  ! ̤ξ
  !-------------------------------------------------------------
  select case(Type)

  case ("Thermal")
    ! ꤵ줿˲̤ 1 ĤǮŪޥͿ. 
    
    Xr = (XMax - XMin) * XrRate
    Xc = (XMax - XMin) * XcRate
    Zr = (ZMax - ZMin) * ZrRate
    Zc = (ZMax - ZMin) * ZcRate
    
    do k = DimZMin, DimZMax
      do i = DimXMin, DimXMax
        beta(i,k) =                                 &
          & (                                       &
          &      ( ( s_X(i) - Xc ) / Xr ) ** 2.0d0  &
          &    + ( ( s_Z(k) - Zc ) / Zr ) ** 2.0d0  &
          &  ) ** 5.0d-1
      end do
    end do
    
    where ( beta < 1.0d0 )
      xz_PotTemp = DelMax * ( dcos( Pi * 5.0d-1 * beta ) ** 2.0d0 )
    end where


  case ("Thermal-Gauss")
    ! ꤵ줿, ʲ̤ξͿ. 

    Xr = (XMax - XMin) * XrRate
    Xc = (XMax - XMin) * XcRate
    Zr = (ZMax - ZMin) * ZrRate
    Zc = (ZMax - ZMin) * ZcRate
    
    do i = DimXMin, DimXMax
      xz_PotTemp(i,:) = &
        & DelMax * dexp( - ( (s_X(i) - Xc) / Xr )**2.0d0 * 5.0d-1 ) 
    end do
    
    do k = DimZMin, DimZMax
      xz_PotTemp(:,k) =  &
        & xz_PotTemp(:,k) * dexp( - ( (s_Z(k) - Zc) / Zr )**2.0d0 * 5.0d-1 ) 
    end do
    
    where ( xz_PotTemp < DelMax * 1.0d-4)
      xz_PotTemp = 0.0d0 
    end where
    
  case ("Exner-Gauss")
    ! ꤵ줿, ʲ̤ξͿ. 

    Xr = (XMax - XMin) * XrRate
    Xc = (XMax - XMin) * XcRate
    Zr = (ZMax - ZMin) * ZrRate
    Zc = (ZMax - ZMin) * ZcRate
    
    do i = DimXMin, DimXMax
      xz_Exner(i,:) = &
        & DelMax * dexp( - ( (s_X(i) - Xc) / Xr )**2.0d0 * 5.0d-1 ) 
    end do
    
    do k = DimZMin, DimZMax
      xz_Exner(:,k) =  &
        & xz_Exner(:,k) * dexp( - ( (s_Z(k) - Zc) / Zr )**2.0d0 * 5.0d-1 ) 
    end do
    
    where ( xz_Exner < DelMax * 1.0d-4)
      xz_Exner = 0.0d0 
    end where
    
  case ("Thermal-Random")
    ! ؤ˥ʾͿ

    open(20,file=RandomFile)
    do i = DimXMin, DimXMax
      read(20,*) random
      xz_PotTemp(i, minloc(s_Z, s_Z > 100.0d3)) = &
        & DelMax * random / xz_ExnerBasicZ(i, minloc(s_Z, s_Z > 100.0d3))
    end do
    close(20)
    
  case ("HS2001")
    ! Hueso and Sanchez-Lavega Ϥ

    i = ( DimXMax - DimXMin - 10) * 5.0d-1
    k = minloc( s_Z, 1, s_Z > 2.5d4 ) - MarginZ
    n = 5.0d3 / DelZ 
    write(*,*) 'DisturbEnv: ', i, k, n

    xz_PotTemp(i-n:i,k-n:k) = DelMax
    
  end select
  !-------------------------------------------------------------
  ! . 
  !-------------------------------------------------------------
  if (Humidity /= 0.0d0) then 
    do i = DimXMin, DimXMax      
      call ECCM_MolFr( SpcWetMolFr(1:SpcNum), Humidity, xz_TempBasicZ(i,:), &
        &              xz_PressBasicZ(i,:), xz_MolFr(i,:,:) )
    end do
    
    !Υ򺮹Ѵ
    do s = 1, SpcNum
      xza_MixRt(:,:,s) =                                                    &
        & xz_MolFr(:,:,s) * MolWtWet(s) / MolWtDry - xza_MixRtBasicZ(:,:,s)
    end do
  end if
  
  
  !ͤʤꤹʤ褦˺ͤͿ
!  where (xza_MixRt <= 1.0d-20 )
!    xza_MixRt = 1.0d-20
!  end where
  
  !
  xza_MixRt = xza_BoundaryXCyc_xza( xza_MixRt )
  xza_MixRt = xza_BoundaryZSym_xza( xza_MixRt )
  

end subroutine DisturbEnv
